import 'package:flutter/material.dart';

import '../../utilities/base_attribute.dart';
import 'align.dart';

/// Alignment utility
class AlignmentUtility {
  /// Alignment on x and y axis
  AlignmentAttribute xy(double x, double y) =>
      AlignmentAttribute(Alignment(x, y));

  /// Bottom center
  AlignmentAttribute get bottomCenter =>
      AlignmentAttribute(Alignment.bottomCenter);

  /// Bottom left
  AlignmentAttribute get bottomLeft => AlignmentAttribute(Alignment.bottomLeft);

  /// Bottom right
  AlignmentAttribute get bottomRight =>
      AlignmentAttribute(Alignment.bottomRight);

  /// Top center
  AlignmentAttribute get topCenter => AlignmentAttribute(Alignment.topCenter);

  /// Top left
  AlignmentAttribute get topLeft => AlignmentAttribute(Alignment.topLeft);

  /// Top right
  AlignmentAttribute get topRight => AlignmentAttribute(Alignment.topRight);

  /// Center
  AlignmentAttribute get center => AlignmentAttribute(Alignment.center);

  /// Center left
  AlignmentAttribute get centerLeft => AlignmentAttribute(Alignment.centerLeft);

  /// Center right
  AlignmentAttribute get centerRight =>
      AlignmentAttribute(Alignment.centerRight);
}

/// Builds aigment utility
Alignment? alignmentUtilityBuilder(List<Attribute> attributes) {
  Alignment? alignment;
  for (final attribute in attributes) {
    if (attribute is AlignmentAttribute) {
      alignment = attribute.alignment;
    }
  }

  return alignment;
}
