import 'package:flutter/material.dart';

import '../../utilities/base_attribute.dart';
import 'color.dart';

// /// Color options
// class ColorOptions {
//   static final String black = '#000000';
//   static final String white = '#ffffff';
//   static final String gray100 = '#f7fafc';
//   static final String gray200 = '#edf2f7';
//   static final String gray300 = '#e2e8f0';
//   static final String gray400 = '#cbd5e0';

//   static final String red100 = '#fff5f5';
//   static final String red200 = '#fed7d7';
//   static final String red300 = '#feb2b2';
//   static final String red400 = '#fc8181';

//   static final String blue100 = '#ebf8ff';
//   static final String blue200 = '#bee3f8';
//   static final String blue300 = '#90cdf4';
//   static final String blue400 = '#63b3ed';

//   static final String green100 = '#f0fff4';
//   static final String green200 = '#c6f6d5';
//   static final String green300 = '#9ae6b4';
//   static final String green400 = '#68d391';
// }

/// Color utility
class ColorUtility<T extends ColorAttribute> {
  /// Constructor
  const ColorUtility();

  /// Select hex color
  T operator [](Color color) => builder(color);

  /// Builder
  T builder(Color color) {
    return ColorAttribute.create<T>(color);
  }
}

/// Color utility builder
Color? colorUtilityBuilder<T extends ColorAttribute>(
  List<Attribute> attributes,
) {
  /// Builds color utility

  Color? color;
  for (final attribute in attributes) {
    if (attribute is T) {
      color = attribute.color;
    }
  }

  return color;
}
