import '../../utilities/base_attribute.dart';
import 'size.dart';

/// Height utility
class SizeUtility<T extends SizeAttribute> {
  /// Sets the height of value
  T operator [](double size) => SizeAttribute.create<T>(size);

  /// Full size
  T get full => SizeAttribute.create<T>(double.infinity);
}

/// Builds height utility
double? sizeUtilityBuilder<T extends SizeAttribute>(
  List<Attribute> attributes,
) {
  double? size;
  for (final attribute in attributes) {
    if (attribute is T) {
      size = attribute.size;
    }
  }
  return size;
}
