import 'package:flutter/material.dart';

import 'attributes/align/align.dart';
import 'attributes/border_radius/border_radius.dart';
import 'attributes/color/color.api.dart';
import 'attributes/size/size.api.dart';
import 'attributes/space/space.api.dart';
import 'mixes/container.mix.dart';
import 'mixes/define_mix.dart';

/// Custom Container
class CustomContainer extends StatelessWidget {
  /// Constructor
  const CustomContainer({
    Key? key,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Container(
      color: Colors.red,
      height: double.infinity,
      child: Center(
        child: ShapeContainer(
          Mix(
            m.xlarge,
            bgColor[Colors.white],
            rounded.small,
            align.center,
            h[100],
            w[200],
          ),
          child: Text('This is the content within a shape.'),
        ),
      ),
    );
  }
}

// m, margin	margin	space
// mt, marginTop	margin-top	space
// mr, marginRight	margin-right	space
// mb, marginBottom	margin-bottom	space
// ml, marginLeft	margin-left	space
// mx	margin-left and margin-right	space
// my
