import '../utilities/base_attribute.dart';
import '../utils.dart';

/// Defines a mix
class Mix {
  const Mix._(this.params);

  /// Define shape with parameters
  factory Mix([
    Attribute? p1,
    Attribute? p2,
    Attribute? p3,
    Attribute? p4,
    Attribute? p5,
    Attribute? p6,
    Attribute? p7,
    Attribute? p8,
    Attribute? p9,
    Attribute? p10,
    Attribute? p11,
    Attribute? p12,
  ]) {
    final params =
        utilityParamToList(p1, p2, p3, p4, p5, p6, p7, p8, p9, p10, p11, p12);
    return Mix._(params);
  }

  final List<Attribute> params;

  /// Merges 2 or 3 shape definitions
  factory Mix.merge([
    Mix? shape1,
    Mix? shape2,
    Mix? shape3,
  ]) {
    final list = <Attribute>[];
    if (shape1 != null) list.addAll(shape1.params);
    if (shape2 != null) list.addAll(shape2.params);
    if (shape3 != null) list.addAll(shape3.params);

    return Mix._(list);
  }
}
